nyoj927 The partial sum problem(dfs)

The partial sum problem

时间限制:1000 ms  |  内存限制:65535 KB

难度:2

描述
One day,Tom’s girlfriend give him an array A which contains N integers and asked him:Can you choose some integers from the N integers and the sum of them is equal to K.

输入
There are multiple test cases.

Each test case contains three lines.The first line is an integer N(1≤N≤20),represents the array contains N integers. The second line contains N integers,the ith integer represents A[i](-10^8≤A[i]≤10^8).The third line contains an integer K(-10^8≤K≤10^8).

输出
If Tom can choose some integers from the array and their them is K,printf ”Of course,I can!”; other printf ”Sorry,I can’t!”.
样例输入
4
1 2 4 7
13
4
1 2 4 7
15
样例输出
Of course,I can!
Sorry,I can‘t!

题意:很简单,就是给你一个数组,和一个值k,是否能从数组中找到n个数之和等于k

思路:直接dfs,不过这个题好像时间有点限制,所以要一个简单的剪枝

Code:

//开始的思路不是很清晰,太盲目的做,因为初始化和回溯的问题wa了两次,然后改好之后又果断超时了,没有考虑剪枝和重复搜索的问题.
//看了一下别人的代码瞬间开窍了,这么简单的题目还wa真是醉了
#include <stdio.h>
#include <string.h>
int a[20],n,k,flage,vis[20];

void dfs(int now,int sum)
{
    int i;
    if(sum>=k)
    {
        if(sum==k)
            flage=1;
        return ;
    }
    else
    {
        for(i=now;i<n;i++)              //这里从now开始就行了,之前的思路是把所有的情况全部考虑了中间会出现重复的情况
        {
            if(vis[i]==0)
            {
                vis[i]=1;
                sum+=a[i];
                dfs(i+1,sum);
                if(flage)               //这里做了一个剪枝,如果已经可以找到,那么后面就不用找了
                    return;
                sum-=a[i];
                vis[i]=0;
            }
        }
    }
}

int main()
{
    int sum,i;
    while(scanf("%d",&n)!=EOF)
    {
        flage=0;
        sum=0;
        memset(vis,0,sizeof(vis));
        for(i=0;i<n;i++)
            scanf("%d",&a[i]);
        scanf("%d",&k);
        dfs(0,0);
        if(flage)
            printf("Of course,I can!\n");
        else
            printf("Sorry,I can't!\n");
    }
    return 0;
}
时间: 2024-12-29 21:29:01

nyoj927 The partial sum problem(dfs)的相关文章

NYOJ-927 The partial sum problem

The partial sum problem 时间限制:1000 ms  |  内存限制:65535 KB 难度:2 描述 One day,Tom's girlfriend give him an array A which contains N integers and asked him:Can you choose some integers from the N integers and the sum of them is equal to K. 输入 There are multi

NYOJ 927 The partial sum problem 【DFS】+【剪枝】

The partial sum problem 时间限制:1000 ms  |  内存限制:65535 KB 难度:2 描写叙述 One day,Tom's girlfriend give him an array A which contains N integers and asked him:Can you choose some integers from the N integers and the sum of them is equal to K. 输入 There are mul

nyoj 927 The partial sum problem(dfs)

描述 One day,Tom’s girlfriend give him an array A which contains N integers and asked him:Can you choose some integers from the N integers and the sum of them is equal to K. 输入 There are multiple test cases. Each test case contains three lines.The firs

NYoj The partial sum problem(简单深搜+优化)

题目链接:http://acm.nyist.edu.cn/JudgeOnline/problem.php?pid=927 代码: 1 #include <stdio.h> 2 #include <stdlib.h> 3 #include <string.h> 4 #include <math.h> 5 #include <algorithm> 6 #include <iostream> 7 using namespace std; 8

2014 Super Training #9 F A Simple Tree Problem --DFS+线段树

原题: ZOJ 3686 http://acm.zju.edu.cn/onlinejudge/showProblem.do?problemCode=3686 这题本来是一个比较水的线段树,结果一个mark坑了我好几个小时..哎.太弱. 先DFS这棵树,树形结构转换为线性结构,每个节点有一个第一次遍历的时间和最后一次遍历的时间,之间的时间戳都为子树的时间戳,用线段树更新这段区间即可实现更新子树的效果,用到懒操作节省时间. 坑我的地方: update时,不能写成:tree[rt].mark = 1,

Maxmum subsequence sum problem

We have a lot of ways to solve the maximum subsequence sum problem, but different ways take different time. 1.Brute-force algorithm int maxSubSum1(const vector<int> &a) { int maxSum=0; for(int i=0;i<a.size();i++) for(int j=i;j<a.size();j++

hdu 2576 Another Sum Problem

题目大意:求前n项和的前n项和. 数学推导题,f(n)=n*(n+1)*(n+2)/6 推导思路如下: #include"cstdio" #include"cstring" #include"cmath" #include"cstdlib" #include"iostream" #include"algorithm" #include"queue" using nam

UvaLive6661 Equal Sum Sets dfs或dp

UvaLive6661 PDF题目 题意:让你用1~n中k个不同的数组成s,求有多少种组法. 题解: DFS或者DP或打表. 1.DFS 由于数据范围很小,直接dfs每种组法统计个数即可. 1 //#pragma comment(linker, "/STACK:102400000,102400000") 2 #include<cstdio> 3 #include<cmath> 4 #include<iostream> 5 #include<cs

[UVALive 6661 Equal Sum Sets] (dfs 或 dp)

题意: 求从不超过 N 的正整数其中选取 K 个不同的数字,组成和为 S 的方法数. 1 <= N <= 20  1 <= K<= 10  1 <= S <= 155 解题思路: DFS: 因为N,K.S的范围非常小.直接DFS就可以. /* ID: [email protected] PROG: LANG: C++ */ #include<map> #include<set> #include<queue> #include<